 % powI(+A, +E, ?P): P is A to the power E (E is an integer >= 0).

pow0(A, E, P) :-
	(   E > 0, E1 is E-1,
	    pow0(A, E1, P1),
	    P is A*P1
	;   E = 0, P = 1
	).

pow1(A, E, P) :-
	(   E > 0 -> E1 is E-1,
	    pow1(A, E1, P1),
	    P is A*P1
	;   E = 0, P = 1
	).

end_of_file.

| ?- consult(pow2), leash(off), trace.
% consulting /home/szeredi/oktatas/dp/angol/ait/code_base/pow2.pl...
% consulted /home/szeredi/oktatas/dp/angol/ait/code_base/pow2.pl in module user, 1 msec -512 bytes
% No leashing
% The debugger will first creep -- showing everything (trace)
yes
% trace,source_info
| ?- pow0(5, 3, P).
        1      1 Call: pow0(5,3,_901)
        2      2 Call: 3>0
        2      2 Exit: 3>0
        3      2 Call: _1431 is 3-1
        3      2 Exit: 2 is 3-1
        4      2 Call: pow0(5,2,_1453)
        5      3 Call: 2>0
        5      3 Exit: 2>0
        6      3 Call: _2133 is 2-1
        6      3 Exit: 1 is 2-1
        7      3 Call: pow0(5,1,_2155)
        8      4 Call: 1>0
        8      4 Exit: 1>0
        9      4 Call: _2835 is 1-1
        9      4 Exit: 0 is 1-1
       10      4 Call: pow0(5,0,_2857)
       11      5 Call: 0>0
       11      5 Fail: 0>0
       12      5 Call: 0=0
       12      5 Exit: 0=0
       13      5 Call: _2857=1
       13      5 Exit: 1=1
       10      4 Exit: pow0(5,0,1)
       14      4 Call: _2155 is 5*1
       14      4 Exit: 5 is 5*1
?       7      3 Exit: pow0(5,1,5)
       15      3 Call: _1453 is 5*5
       15      3 Exit: 25 is 5*5
?       4      2 Exit: pow0(5,2,25)
       16      2 Call: _901 is 5*25
       16      2 Exit: 125 is 5*25
?       1      1 Exit: pow0(5,3,125)
P = 125 ? ;
        1      1 Redo: pow0(5,3,125)
        4      2 Redo: pow0(5,2,25)
        7      3 Redo: pow0(5,1,5)
       17      4 Call: 1=0
       17      4 Fail: 1=0
        7      3 Fail: pow0(5,1,_2155)
       18      3 Call: 2=0
       18      3 Fail: 2=0
        4      2 Fail: pow0(5,2,_1453)
       19      2 Call: 3=0
       19      2 Fail: 3=0
        1      1 Fail: pow0(5,3,_901)
no
% trace,source_info
| ?- pow1(5, 3, P).
        1      1 Call: pow1(5,3,_901)
        2      2 Call: 3>0
        2      2 Exit: 3>0
        3      2 Call: _1431 is 3-1
        3      2 Exit: 2 is 3-1
        4      2 Call: pow1(5,2,_1453)
        5      3 Call: 2>0
        5      3 Exit: 2>0
        6      3 Call: _2137 is 2-1
        6      3 Exit: 1 is 2-1
        7      3 Call: pow1(5,1,_2159)
        8      4 Call: 1>0
        8      4 Exit: 1>0
        9      4 Call: _2843 is 1-1
        9      4 Exit: 0 is 1-1
       10      4 Call: pow1(5,0,_2865)
       11      5 Call: 0>0
       11      5 Fail: 0>0
       12      5 Call: 0=0
       12      5 Exit: 0=0
       13      5 Call: _2865=1
       13      5 Exit: 1=1
       10      4 Exit: pow1(5,0,1)
       14      4 Call: _2159 is 5*1
       14      4 Exit: 5 is 5*1
        7      3 Exit: pow1(5,1,5)
       15      3 Call: _1453 is 5*5
       15      3 Exit: 25 is 5*5
        4      2 Exit: pow1(5,2,25)
       16      2 Call: _901 is 5*25
       16      2 Exit: 125 is 5*25
        1      1 Exit: pow1(5,3,125)
P = 125 ? ;
no
% trace,source_info
| ?- 

