has_parent('Charles', 'Elizabeth').
has_parent('Andrew',  'Elizabeth').   
has_parent('William', 'Charles').
has_parent('Beatrice', 'Andrew').
has_parent('Harry',   'Charles').
has_parent('Eugenie', 'Andrew').

has_grandparent(GC, GP) :- 
         has_parent(GC, P),
	 has_parent(P, GP).

has_sibling(A, B) :-
        has_parent(A, P),
	has_parent(B, P),
	\+ A = B.          % also available as A \= B.

has_cousin(A, B) :-
        has_grandparent(A, GP),
	has_grandparent(B, GP), 
        \+ has_sibling(A, B),
	\+ A = B.

