has_parent('Charles', 'Elizabeth').
has_parent('Charles', 'Philip').
has_parent('Andrew',  'Elizabeth').
has_parent('Andrew',  'Philip').
has_parent('William', 'Diana').
has_parent('William', 'Charles').
has_parent('Harry',   'Diana').
has_parent('Harry',   'Charles').
has_parent('George',  'Catherine').
has_parent('George',  'William').

% has_anc(+N, ?D, ?A):  D has A as their Nth generation ancestor.
% The 1st,     2nd,          3rd  generation ancestors are
%     parents, grandparents, great-grandparents etc. 
has_anc(N, D, A) :-
	(   N =:= 1 -> has_parent(D, A)
	;   N > 1, has_parent(D, P), M is N-1, has_anc(M, P, A)
	).

has_anc2(N, D, A) :-
	has_parent(D, P),
	(   N > 1 -> M is N-1, has_anc(M, P, A)
    ;   A = P                              
	).                                     
