% append0(L1, L2, L3, L123): 
% L123 is the concatenation of L1, L2, and L3.
% Inefficient.
append0(L1, L2, L3, L123) :-
        append(L1, L2, L12), append(L12, L3, L123).

% append(L1, L2, L3, L123): 
% L123 is the concatenation of L1, L2, and L3.
append(L1, L2, L3, L123) :-
        append(L1, L23, L123), append(L2, L3, L23).
	
end_of_file.

| ?- sequence(5, L), append0(L, [13], [17], L2).
L = [1,2,3,4,5],
L2 = [1,2,3,4,5,13,17] ? ;
no
| ?- sequence(5, L), append(L, [13], [17], L2).
L = [1,2,3,4,5],
L2 = [1,2,3,4,5,13,17] ? ;
no
| ?- use_module('../timing/time').
(...)
yes
| ?- run_test(append(_L, [13], [17], _), _L, sequence).
length=1000     run time =   0.00 sec, total time =   0.00 sec 
length=10000    run time =   0.00 sec, total time =   0.00 sec 
length=20000    run time =   0.00 sec, total time =   0.00 sec 
length=100000   run time =   0.00 sec, total time =   0.00 sec 
length=200000   run time =   0.00 sec, total time =   0.00 sec 
length=1000000  run time =   0.01 sec, total time =   0.01 sec 
length=2000000  run time =   0.01 sec, total time =   0.01 sec 
length=4000000  run time =   0.03 sec, total time =   0.03 sec 
length=8000000  run time =   0.06 sec, total time =   0.06 sec 
Completed
yes
| ?- run_test(append0(_L, [13], [17], _), _L, sequence).
length=1000     run time =   0.00 sec, total time =   0.00 sec 
length=10000    run time =   0.00 sec, total time =   0.00 sec 
length=20000    run time =   0.01 sec, total time =   0.01 sec 
length=100000   run time =   0.00 sec, total time =   0.00 sec 
length=200000   run time =   0.00 sec, total time =   0.00 sec 
length=1000000  run time =   0.02 sec, total time =   0.02 sec 
length=2000000  run time =   0.03 sec, total time =   0.03 sec 
length=4000000  run time =   0.06 sec, total time =   0.06 sec 
length=8000000  run time =   0.13 sec, total time =   0.13 sec 
Completed
yes
| ?- append(A, B, C, []).
A = [],
B = [],
C = [] ? ;
no
| ?- append0(A, B, C, []).
A = [],
B = [],
C = [] ? ;
  C-c C-cProlog interruption (h for help)? a
% Execution aborted
| ?- 
