a(X, Y) :- b(X), c(X, Y).
a(X, Y) :- e(X, Y).

b(s(1)).
b(s(2)).

c(s(X), Y) :- Y is X+10.
c(s(X), Y) :- Y is X+20.

e(s(3), 30).
e(t(4), 40).

a_cut(X, Y) :- b(X), !, c(X, Y).
a_cut(X, Y) :- e(X, Y).

test(Pred, X, Res) :-
    findall(X-Y, call(Pred, X, Y), Res).

end_of_file.

| ?- test(a, s(_), Res).
Res = [s(1)-11,s(1)-21,s(2)-12,s(2)-22,s(3)-30] ? 
yes
| ?- test(a, t(_), Res).
Res = [t(4)-40] ? 
yes
| ?- test(a_cut, s(_), Res).
Res = [s(1)-11,s(1)-21] ? 
yes
| ?- test(a_cut, s(3), Res).
Res = [s(3)-30] ? 
yes
| ?- test(a_cut, t(_), Res).
Res = [t(4)-40] ? 
yes
| ?- 
