% One can get from State0 to a final state State, using transitions next/2.
loop(State0, State) :-                
        (   final(State0) -> State = State0
        ;   next(State0, State1),
				% must leave no choice points, for LCO to work.
            loop(State1, State)
        ).


sum_list(L, Sum) :-
	loop(L-0, []-Sum).

final([]-_).

next([X|L]-S0, L-S1) :-
	S1 is S0+X.
