% fact0(N, F): F = N!.
fact0(N, F) :-
    (   N = 0 ->  F = 1                              
    ;   N > 0, N1 is N-1,
	fact0(N1, F1),
	F is N*F1 
    ).      

% fact(N, F): F = N!.	       
fact(N, F) :-     
    fact(N, 1, F).

% fact(N, F0, F): F = F0*N!.                                 
fact(N, F0, F) :-                                            
    (   N = 0 -> F = F0                                     
    ;   N > 0,
	F1 is F0*N,
	N1 is N-1,
	fact(N1, F1, F)
    ).                                                

end_of_file.

%  This file HAS TO BE CONSULTED, rather than compiled, otherwise spypoints
%  for is/2 will not work.

| ?- spy(is/2, [line(6)]).
% The debugger will first zip -- showing spypoints (zip)
% Conditional spypoint for prolog:is/2 added, BID=1
* Predicate prolog:is/2 compiled inline, breakable only in interpreted code
yes
% zip
| ?- fact0(4, F).
 *      1      1 Call: _866 is 1*1 ? l
 *      1      1 Exit: 1 is 1*1 ? l
 *      2      1 Call: _793 is 2*1 ? l
 *      2      1 Exit: 2 is 2*1 ? l
 *      3      1 Call: _720 is 3*2 ? l
 *      3      1 Exit: 6 is 3*2 ? l
 *      4      1 Call: _523 is 4*6 ? l
 *      4      1 Exit: 24 is 4*6 ? l
F = 24 ? ;
no
% zip
| ?- spy(is/2, [line(17)]).
% Conditional spypoint for prolog:is/2 added, BID=2
* Predicate prolog:is/2 compiled inline, breakable only in interpreted code
yes
% zip
| ?- fact(4, F).
 *      1      1 Call: _725 is 1*4 ? l
 *      1      1 Exit: 4 is 1*4 ? l
 *      6      2 Call: _1916 is 4*3 ? l
 *      6      2 Exit: 12 is 4*3 ? l
 *     11      3 Call: _3120 is 12*2 ? l
 *     11      3 Exit: 24 is 12*2 ? l
 *     16      4 Call: _4324 is 24*1 ? l
 *     16      4 Exit: 24 is 24*1 ? l
F = 24 ? ;
no
% zip
| ?-
