% value_of0(+Poly, +X, ?V): V is the value of the formula Poly, for x=X
% Poly is built from the atom x and numbers using the operators + and *.
value_of0(x, X, V) :-
        V = X.
value_of0(N, _, V) :-                
        number(N), V = N.
value_of0(P1+P2, X, V) :-                    
        value_of0(P1, X, V1),                
        value_of0(P2, X, V2),                
        V is V1+V2.                       
value_of0(P1*P2, X, V) :-       
        value_of0(P1, X, V1),   
        value_of0(P2, X, V2),   
        V is V1*V2.          

end_of_file.

| ?- value_of0((x+1)*x+x+2*(x+x+3), 2, V).
V = 22 ? ;
no
| ?- 
