:- use_module(library(clpfd)).

ex1(Z) :-
	X in {4,9}, Y in {2,3}, Z #= X-Y.

ex2(Z) :-
	X in {4,9}, Z #= X-2.

ex3(Z) :-
	X in {4,9}, Y in {2,3},
	scalar_product([1,-1], [X,Y], #=, Z, [consistency(domain)]).

ex4a(X, Y) :-
	domain([X,Y],-9,9), X*X+2*X+1 #= Y.

ex4b(X, Y) :-
	domain([X,Y],-9,9), (X+1)*(X+1) #= Y.

end_of_file.


| ?- ex1(Z).
Z in 1..7 ? 
yes
| ?- ex2(Z).
Z in{2}\/{7} ? 
yes
| ?- ex3(Z).
Z in(1..2)\/(6..7) ? 
yes
| ?- ex4a(X, Y).
X in-4..4,
Y in-7..9 ? 
yes
| ?- ex4b(X, Y).
X in-4..2,
Y in 0..9 ? 
yes
| ?- listing([ex4a,ex4b]).
ex4a(X, Y) :-
        clpfd:domain([X,Y], -9, 9),
        clpfd:'x*x=y'(X, Z),
        clpfd:scalar_product([1,-2,-1], [Y,X,Z], #=, 1).

ex4b(X, Y) :-
        clpfd:domain([X,Y], -9, 9),
        clpfd:'t=u+c'(Z, X, 1),
        clpfd:'x*x=y'(Z, Y).

yes
| ?- 

