% select(Elem, List, Rest): Elem is an element of List, and removing it from
% List results in list Rest.

select(Elem, [Elem|Rest], Rest).       % The head is removed, the tail remains.
select(Elem, [X|Tail], [X|Rest0]) :-   % The head remains,
        select(Elem, Tail, Rest0).     %     the element is removed from the Tail.
